## modules 0.1.0

=== DESCRIPTION ===
Package: modules
Title: Self Contained Units of Source Code
Version: 0.1.0
Date: 2015-12-18
Authors@R: person("Sebastian", "Warnholz", email = "wahani@gmail.com", role = c("aut", "cre"))
Description: Provides modules as an organizational unit for source code. Modules
    enforce to be more rigorous when defining dependencies and have
    a local search path. They can be used as a sub unit within packages
    or in scripts.
BugReports: https://github.com/wahani/modules/issues
Depends: R (>= 3.2.2), aoos, methods
License: GPL-3 | file LICENSE
Encoding: UTF-8
LazyData: true
Suggests: disposables, testthat, devtools, knitr, parallel
RoxygenNote: 5.0.1
Collate: 'NAMESPACE.R' 'module.R' 'module-class.R' 'module-coercion.R'
        'module-helper.R'
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2015-12-19 17:18:36 UTC; sebastian
Author: Sebastian Warnholz [aut, cre]
Maintainer: Sebastian Warnholz <wahani@gmail.com>
Repository: CRAN
Date/Publication: 2015-12-19 19:07:23

## modules 0.2.0

=== DESCRIPTION ===
Package: modules
Title: Self Contained Units of Source Code
Version: 0.2.0
Date: 2016-01-06
Authors@R: person("Sebastian", "Warnholz", email = "wahani@gmail.com", role = c("aut", "cre"))
Description: Provides modules as an organizational unit for source code. Modules
    enforce to be more rigorous when defining dependencies and have
    a local search path. They can be used as a sub unit within packages
    or in scripts.
BugReports: https://github.com/wahani/modules/issues
URL: https://github.com/wahani/modules
ByteCompile: TRUE
Depends: R (>= 3.2.2), aoos, methods
Imports: stringr
License: GPL-3 | file LICENSE
Encoding: UTF-8
LazyData: true
Suggests: disposables, testthat, devtools, knitr, parallel
RoxygenNote: 5.0.1
Collate: 'NAMESPACE.R' 'modfun.R' 'module.R' 'module-class.R'
        'module-coercion.R' 'module-helper.R' 'getSearchPath.R'
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2016-01-06 13:31:49 UTC; sebastian
Author: Sebastian Warnholz [aut, cre]
Maintainer: Sebastian Warnholz <wahani@gmail.com>
Repository: CRAN
Date/Publication: 2016-01-06 17:22:35

## modules 0.3.0

=== DESCRIPTION ===
Package: modules
Title: Self Contained Units of Source Code
Version: 0.3.0
Date: 2016-02-22
Authors@R: person("Sebastian", "Warnholz", email = "wahani@gmail.com", role = c("aut", "cre"))
Description: Provides modules as an organizational unit for source code. Modules
    enforce to be more rigorous when defining dependencies and have
    a local search path. They can be used as a sub unit within packages
    or in scripts.
BugReports: https://github.com/wahani/modules/issues
URL: https://github.com/wahani/modules
ByteCompile: TRUE
Depends: R (>= 3.2.2), aoos, methods
Imports: stringr, utils
License: GPL-3 | file LICENSE
Encoding: UTF-8
LazyData: true
Suggests: disposables, testthat, devtools, knitr, rmarkdown, parallel
RoxygenNote: 5.0.1
Collate: 'NAMESPACE.R' 'getSearchPath.R' 'modfun.R' 'module-class.R'
        'module-coercion.R' 'module-helper.R' 'module.R'
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2016-02-23 06:54:04 UTC; sebastian
Author: Sebastian Warnholz [aut, cre]
Maintainer: Sebastian Warnholz <wahani@gmail.com>
Repository: CRAN
Date/Publication: 2016-02-23 08:16:09

## modules 0.4.0

=== DESCRIPTION ===
Package: modules
Title: Self Contained Units of Source Code
Version: 0.4.0
Date: 2016-04-07
Authors@R: person("Sebastian", "Warnholz", email = "wahani@gmail.com", role = c("aut", "cre"))
Description: Provides modules as an organizational unit for source code. Modules
    enforce to be more rigorous when defining dependencies and have
    a local search path. They can be used as a sub unit within packages
    or in scripts.
BugReports: https://github.com/wahani/modules/issues
URL: https://github.com/wahani/modules
ByteCompile: TRUE
Depends: R (>= 3.2.0), aoos, methods
Imports: stringr, utils
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Suggests: disposables, testthat, devtools, knitr, rmarkdown, parallel
RoxygenNote: 5.0.1
Collate: 'NAMESPACE.R' 'getSearchPath.R' 'modfun.R' 'module-class.R'
        'module-coercion.R' 'module-helper.R' 'module.R'
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2016-04-07 14:34:10 UTC; sebastian
Author: Sebastian Warnholz [aut, cre]
Maintainer: Sebastian Warnholz <wahani@gmail.com>
Repository: CRAN
Date/Publication: 2016-04-07 18:27:31

## modules 0.5.0

=== DESCRIPTION ===
Package: modules
Title: Self Contained Units of Source Code
Version: 0.5.0
Date: 2016-11-01
Authors@R: person("Sebastian", "Warnholz", email = "wahani@gmail.com", role = c("aut", "cre"))
Description: Provides modules as an organizational unit for source code. Modules
    enforce to be more rigorous when defining dependencies and have
    a local search path. They can be used as a sub unit within packages
    or in scripts.
BugReports: https://github.com/wahani/modules/issues
URL: http://wahani.github.io/modules
ByteCompile: TRUE
Depends: R (>= 3.2.0)
Imports: stringr, utils
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Suggests: disposables, testthat, devtools, knitr, lintr, rmarkdown,
        parallel
RoxygenNote: 5.0.1
Collate: 'NAMESPACE.R' 'getSearchPath.R' 'module-class.R'
        'module-coercion.R' 'module-helper.R' 'module.R'
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2016-11-02 07:47:29 UTC; sebastian
Author: Sebastian Warnholz [aut, cre]
Maintainer: Sebastian Warnholz <wahani@gmail.com>
Repository: CRAN
Date/Publication: 2016-11-02 18:15:31

## modules 0.6.0

=== DESCRIPTION ===
Package: modules
Title: Self Contained Units of Source Code
Version: 0.6.0
Date: 2017-07-18
Authors@R: person("Sebastian", "Warnholz", email = "wahani@gmail.com", role = c("aut", "cre"))
Description: Provides modules as an organizational unit for source code. Modules
    enforce to be more rigorous when defining dependencies and have
    a local search path. They can be used as a sub unit within packages
    or in scripts.
BugReports: https://github.com/wahani/modules/issues
URL: http://wahani.github.io/modules
ByteCompile: TRUE
Depends: R (>= 3.2.0)
Imports: stringr, utils
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Suggests: disposables, testthat, devtools, knitr, lintr, rmarkdown,
        parallel
RoxygenNote: 6.0.1
Collate: 'NAMESPACE.R' 'getSearchPath.R' 'class.R' 'export.R'
        'expose.R' 'extend.R' 'import.R' 'module-class.R'
        'module-coercion.R' 'module-helper.R' 'module.R' 'use.R'
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2017-07-22 15:27:55 UTC; sebastian
Author: Sebastian Warnholz [aut, cre]
Maintainer: Sebastian Warnholz <wahani@gmail.com>
Repository: CRAN
Date/Publication: 2017-07-22 20:52:38 UTC

## modules 0.7.0

=== DESCRIPTION ===
Package: modules
Title: Self Contained Units of Source Code
Version: 0.7.0
Authors@R: person("Sebastian", "Warnholz", email = "wahani@gmail.com", role = c("aut", "cre"))
Description: Provides modules as an organizational unit for source code. Modules
    enforce to be more rigorous when defining dependencies and have
    a local search path. They can be used as a sub unit within packages
    or in scripts.
BugReports: https://github.com/wahani/modules/issues
URL: http://wahani.github.io/modules
ByteCompile: TRUE
Depends: R (>= 3.2.0)
Imports: stringr, utils
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Suggests: disposables, testthat, devtools, knitr, lintr, rmarkdown,
        parallel
RoxygenNote: 6.0.1
Collate: 'amodule.R' 'NAMESPACE.R' 'getSearchPath.R' 'class.R'
        'depend.R' 'export.R' 'expose.R' 'extend.R' 'import.R'
        'module-class.R' 'module-coercion.R' 'module-helper.R'
        'module.R' 'use.R' 'testModule.R'
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2018-07-15 16:57:26 UTC; sebastian
Author: Sebastian Warnholz [aut, cre]
Maintainer: Sebastian Warnholz <wahani@gmail.com>
Repository: CRAN
Date/Publication: 2018-07-15 21:40:03 UTC

## modules 0.8.0

=== DESCRIPTION ===
Package: modules
Title: Self Contained Units of Source Code
Version: 0.8.0
Authors@R: person("Sebastian", "Warnholz", email = "wahani@gmail.com", role = c("aut", "cre"))
Description: Provides modules as an organizational unit for source code. Modules
    enforce to be more rigorous when defining dependencies and have
    a local search path. They can be used as a sub unit within packages
    or in scripts.
BugReports: https://github.com/wahani/modules/issues
URL: http://wahani.github.io/modules
ByteCompile: TRUE
Depends: R (>= 3.2.0)
Imports: utils
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Suggests: disposables, testthat, devtools, knitr, lintr, rmarkdown,
        parallel
RoxygenNote: 6.1.0
Collate: 'amodule.R' 'NAMESPACE.R' 'getSearchPath.R' 'class.R'
        'depend.R' 'export.R' 'expose.R' 'extend.R' 'import.R'
        'module-class.R' 'module-coercion.R' 'module-helper.R'
        'module.R' 'use.R' 'testModule.R' 'base-override.R'
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2019-02-10 10:49:10 UTC; sebastian
Author: Sebastian Warnholz [aut, cre]
Maintainer: Sebastian Warnholz <wahani@gmail.com>
Repository: CRAN
Date/Publication: 2019-02-10 11:10:04 UTC

## modules 0.9.0

=== DESCRIPTION ===
Package: modules
Title: Self Contained Units of Source Code
Version: 0.9.0
Authors@R: person("Sebastian", "Warnholz", email = "wahani@gmail.com", role = c("aut", "cre"))
Description: Provides modules as an organizational unit for source code. Modules
    enforce to be more rigorous when defining dependencies and have
    a local search path. They can be used as a sub unit within packages
    or in scripts.
BugReports: https://github.com/wahani/modules/issues
URL: https://github.com/wahani/modules
ByteCompile: TRUE
Depends: R (>= 3.2.0)
Imports: utils
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Suggests: testthat, devtools, knitr, lintr, rmarkdown, parallel
RoxygenNote: 7.1.1
Collate: 'amodule.R' 'NAMESPACE.R' 'getSearchPath.R' 'class.R'
        'depend.R' 'export.R' 'expose.R' 'extend.R' 'import.R'
        'module-class.R' 'module-coercion.R' 'module-helper.R'
        'module.R' 'use.R' 'testModule.R' 'base-override.R'
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2021-01-31 07:35:35 UTC; swarnholz
Author: Sebastian Warnholz [aut, cre]
Maintainer: Sebastian Warnholz <wahani@gmail.com>
Repository: CRAN
Date/Publication: 2021-01-31 08:00:02 UTC

## modules 0.10.0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: modules
 Title: Self Contained Units of Source Code
-Version: 0.9.0
+Version: 0.10.0
 Authors@R: person("Sebastian", "Warnholz", email = "wahani@gmail.com", role = c("aut", "cre"))
 Description: Provides modules as an organizational unit for source code. Modules
     enforce to be more rigorous when defining dependencies and have
@@ -22,8 +22,8 @@
         'module.R' 'use.R' 'testModule.R' 'base-override.R'
 VignetteBuilder: knitr
 NeedsCompilation: no
-Packaged: 2021-01-31 07:35:35 UTC; swarnholz
+Packaged: 2021-02-06 21:03:36 UTC; lswarnholz
 Author: Sebastian Warnholz [aut, cre]
 Maintainer: Sebastian Warnholz <wahani@gmail.com>
 Repository: CRAN
-Date/Publication: 2021-01-31 08:00:02 UTC
+Date/Publication: 2021-02-06 22:40:03 UTC

## modules 0.11.0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: modules
 Title: Self Contained Units of Source Code
-Version: 0.10.0
+Version: 0.11.0
 Authors@R: person("Sebastian", "Warnholz", email = "wahani@gmail.com", role = c("aut", "cre"))
 Description: Provides modules as an organizational unit for source code. Modules
     enforce to be more rigorous when defining dependencies and have
@@ -13,17 +13,16 @@
 Imports: utils
 License: MIT + file LICENSE
 Encoding: UTF-8
-LazyData: true
 Suggests: testthat, devtools, knitr, lintr, rmarkdown, parallel
-RoxygenNote: 7.1.1
+RoxygenNote: 7.1.2
 Collate: 'amodule.R' 'NAMESPACE.R' 'getSearchPath.R' 'class.R'
         'depend.R' 'export.R' 'expose.R' 'extend.R' 'import.R'
         'module-class.R' 'module-coercion.R' 'module-helper.R'
         'module.R' 'use.R' 'testModule.R' 'base-override.R'
 VignetteBuilder: knitr
 NeedsCompilation: no
-Packaged: 2021-02-06 21:03:36 UTC; lswarnholz
+Packaged: 2023-06-10 10:26:46 UTC; lswarnholz
 Author: Sebastian Warnholz [aut, cre]
 Maintainer: Sebastian Warnholz <wahani@gmail.com>
 Repository: CRAN
-Date/Publication: 2021-02-06 22:40:03 UTC
+Date/Publication: 2023-06-10 11:30:02 UTC

## modules 0.12.0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: modules
 Title: Self Contained Units of Source Code
-Version: 0.11.0
+Version: 0.12.0
 Authors@R: person("Sebastian", "Warnholz", email = "wahani@gmail.com", role = c("aut", "cre"))
 Description: Provides modules as an organizational unit for source code. Modules
     enforce to be more rigorous when defining dependencies and have
@@ -21,8 +21,8 @@
         'module.R' 'use.R' 'testModule.R' 'base-override.R'
 VignetteBuilder: knitr
 NeedsCompilation: no
-Packaged: 2023-06-10 10:26:46 UTC; lswarnholz
+Packaged: 2023-08-25 13:14:13 UTC; lswarnholz
 Author: Sebastian Warnholz [aut, cre]
 Maintainer: Sebastian Warnholz <wahani@gmail.com>
 Repository: CRAN
-Date/Publication: 2023-06-10 11:30:02 UTC
+Date/Publication: 2023-08-25 13:50:05 UTC

## modules 0.13.0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: modules
 Title: Self Contained Units of Source Code
-Version: 0.12.0
+Version: 0.13.0
 Authors@R: person("Sebastian", "Warnholz", email = "wahani@gmail.com", role = c("aut", "cre"))
 Description: Provides modules as an organizational unit for source code. Modules
     enforce to be more rigorous when defining dependencies and have
@@ -21,8 +21,8 @@
         'module.R' 'use.R' 'testModule.R' 'base-override.R'
 VignetteBuilder: knitr
 NeedsCompilation: no
-Packaged: 2023-08-25 13:14:13 UTC; lswarnholz
+Packaged: 2024-01-20 15:43:02 UTC; lswarnholz
 Author: Sebastian Warnholz [aut, cre]
 Maintainer: Sebastian Warnholz <wahani@gmail.com>
 Repository: CRAN
-Date/Publication: 2023-08-25 13:50:05 UTC
+Date/Publication: 2024-01-21 12:00:02 UTC

## modules 3.2.9c

=== debian/changelog ===
modules (3.2.9c-3) unstable; urgency=low

  * Fix broken bash completion. Thanks to Alexy Brodkin for patch.
    Closes: #691521 

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 04 Nov 2012 14:51:25 +0000

modules (3.2.9c-2) unstable; urgency=low

  * B-D on tcl8.5-dev, not tcl8.5 only.   Closes: #671522.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 05 May 2012 19:57:57 +0100

modules (3.2.9c-1) unstable; urgency=low

  * Initial release. (Closes: #583484)

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 13 Apr 2012 11:14:56 +0100

=== debian/control ===
Source: modules
Section: devel
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Standards-Version: 3.9.3
Homepage: http://modules.sourceforge.net/
Build-Depends: tcl8.5-dev, debhelper (>= 8.1.3~), dejagnu

Package: environment-modules
Architecture: any
Depends: debhelper (>= 8.1.3), tcl8.5, ${misc:Depends}, ${shlibs:Depends}
Description: Modular system for handling environment variables
 The Modules package provides for the dynamic modification of a user's
 environment via modulefiles.  Each modulefile contains the information
 needed to configure the shell for an application. Once the Modules
 package is initialized, the environment can be modified dynamically
 on a per-module basis using the module command which interprets
 modulefiles. Typically modulefiles instruct the module command to alter or
 set shell environment variables such as PATH, MANPATH, etc. modulefiles
 may be shared by many users on a system and users may have their own
 collection to supplement or replace the shared modulefiles.  The modules
 environment is common on SGI/Crays and many workstation farms.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

TDIR=debian/environment-modules

# The magic debhelper  rule
%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- \
                --prefix=/usr  --with-version-path=/usr/share/modules/versions \
		--with-module-path=/usr/share/modules/modulefiles \
		--bindir=/usr/bin

override_dh_auto_install:
	dh_auto_install
	# Fix brain-dead install locations.
	mv ${TDIR}/usr/Modules/*/bin/* ${TDIR}/usr/bin
	rmdir ${TDIR}/usr/Modules/*/bin
	mv ${TDIR}/usr/Modules/*/init/bash_completion ${TDIR}/etc/bash_completion.d/modules
	mv ${TDIR}/usr/Modules/*/share/* ${TDIR}/usr/share
	mv ${TDIR}/usr/Modules/*/init ${TDIR}/usr/share/modules
	mv ${TDIR}/usr/Modules/*/modulefiles ${TDIR}/usr/share/modules
	rmdir ${TDIR}/usr/Modules/*/share
	mv ${TDIR}/usr/Modules ${TDIR}/usr/share/modules
	cp debian/csh ${TDIR}/etc/csh/login.d/modules
	cp debian/sh  ${TDIR}/etc/profile.d/modules.sh

## modules 3.2.10

=== debian/changelog ===
modules (3.2.10-8) unstable; urgency=medium

  [Yaroslav O. Halchenko]
  * debian/sh
   - enable init script for zsh. Closes #731974.
  * Add support for tcl < 8.6.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 12 Dec 2013 06:34:42 +0000

modules (3.2.10-7) unstable; urgency=low

  * Add /etc/environment-modules/modulespath as conffile; 
    /usr/share/init/.modulespath  points to this. Closes: #711955
  * Add /etc/environment-modules/modules ; include in modulespath.
  * Patch for fixing minor compiler warnings from lintian.
  * Standards-Version: 3.9.5. 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 29 Nov 2013 18:24:31 +0000

modules (3.2.10-6) unstable; urgency=low

  * Fix testsuite breakage on kFreeBSD

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 10 Nov 2013 18:50:04 +0000

modules (3.2.10-5) unstable; urgency=low

  * Undo tcl8.6-dev change until the transition as it breaks buildds.
    Closes: #726890.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 26 Oct 2013 22:09:35 +0100

modules (3.2.10-4) unstable; urgency=low

  * Replace tcl8.6-dev by tcl-dev | tcl8.6-dev for FTBFS in experimental
    Closes: #725010. 
  * Added Patch for uname version strings with braces in them.
  * Enable syslog functionality.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 Oct 2013 09:50:10 +0100

modules (3.2.10-3) unstable; urgency=low

  * Fixes needed for -Werror=format-security.  

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 12 Jun 2013 09:20:40 +0100

modules (3.2.10-2) unstable; urgency=low

  * Move from tcl8.5 to tcl8.6. 
  * Minor fix needed for hardening; dh_compat=9

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 11 Jun 2013 13:34:08 +0100

modules (3.2.10-1) unstable; urgency=low

  * New upstream release. Closes: #397906.
  * Fix ksh completion patch. Thanks to Bastian Neuberger. Closes: #697685.
  * Now at Standards-Version: 3.9.4
  * Move to Debhelper dependency >=9.
  * Add hardening, linking as-needed.
  * Add watch file thanks to Bart Martens.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 26 Jan 2013 15:04:02 +0000

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: devel
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Standards-Version: 3.9.3
+Standards-Version: 3.9.5
 Homepage: http://modules.sourceforge.net/
-Build-Depends: tcl8.5-dev, debhelper (>= 8.1.3~), dejagnu
+Build-Depends: tcl8.6-dev | tcl-dev, debhelper (>= 9), dejagnu
 
 Package: environment-modules
 Architecture: any
-Depends: debhelper (>= 8.1.3), tcl8.5, ${misc:Depends}, ${shlibs:Depends}
+Depends: debhelper (>= 9), tcl8.6 | tcl, ${misc:Depends}, ${shlibs:Depends}
 Description: Modular system for handling environment variables
  The Modules package provides for the dynamic modification of a user's
  environment via modulefiles.  Each modulefile contains the information

=== debian/rules ===
--- 
+++ 
@@ -1,18 +1,29 @@
 #!/usr/bin/make -f
 
-export DH_VERBOSE=1
+# export DH_VERBOSE=1
 
 TDIR=debian/environment-modules
+
+DEB_BUILD_MAINT_OPTIONS:=hardening=+all
+DEB_CFLAGS_MAINT_APPEND:= -Wall -pedantic
+DEB_LDFLAGS_MAINT_APPEND:= -Wl,--as-needed
+export  DEB_BUILD_MAINT_OPTIONS DEB_CFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_APPEND
 
 # The magic debhelper  rule
 %:
 	dh $@ 
 
+override_dh_auto_clean:
+	dh_auto_clean
+	rm -f stamp-h
+
 override_dh_auto_configure:
 	dh_auto_configure -- \
                 --prefix=/usr  --with-version-path=/usr/share/modules/versions \
 		--with-module-path=/usr/share/modules/modulefiles \
-		--bindir=/usr/bin
+		--with-tcl-ver=8.6 \
+		--enable-logging \
+		--bindir=/usr/bin LDFLAGS='$(LDFLAGS) -Wl,--as-needed' CFLAGS='$(CFLAGS) '
 
 override_dh_auto_install:
 	dh_auto_install
@@ -27,3 +38,6 @@
 	mv ${TDIR}/usr/Modules ${TDIR}/usr/share/modules
 	cp debian/csh ${TDIR}/etc/csh/login.d/modules
 	cp debian/sh  ${TDIR}/etc/profile.d/modules.sh
+	cp debian/modulespath ${TDIR}/etc/environment-modules/modulespath
+	rm ${TDIR}/usr/share/modules/init/.modulespath
+	dh_link /etc/environment-modules/modulespath /usr/share/modules/init/.modulespath

## modules 4.0.0

=== Makefile ===
.PHONY: doc pkgdoc initdir install uninstall dist dist-tar dist-gzip \
	dist-bzip2 srpm clean distclean test testinstall instrument testcoverage

# definitions for code coverage
NAGELFAR_RELEASE := nagelfar125
NAGELFAR := $(NAGELFAR_RELEASE)/nagelfar.tcl
COVERAGE_SRCFILE := modulecmd.tcl
COVERAGE_IFILE := $(COVERAGE_SRCFILE:.tcl=.tcl_i)
COVERAGE_LOGFILE := $(COVERAGE_SRCFILE:.tcl=.tcl_log)
COVERAGE_MFILE := $(COVERAGE_SRCFILE:.tcl=.tcl_m)

# compatibility version-related files
COMPAT_DIR := compat

# source definitions shared across the Makefiles of this project
ifneq ($(wildcard Makefile.inc),Makefile.inc)
  $(error Makefile.inc is missing, please run './configure')
endif
include Makefile.inc

all: initdir pkgdoc modulecmd.tcl ChangeLog README \
	contrib/scripts/add.modules
ifeq ($(compatversion),y)
all: $(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog
else
endif

initdir: version.inc
	make -C init all

pkgdoc: version.inc
	make -C doc man txt

doc: version.inc
	make -C doc all

# build version.inc shared definitions from git repository info
ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
GIT_CURRENT_TAG := $(shell git describe --tags --abbrev=0)
GIT_CURRENT_DESC := $(shell git describe --tags --dirty=-wip)
GIT_CURRENT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD)

MODULES_RELEASE := $(subst v,,$(GIT_CURRENT_TAG))
MODULES_BUILD_DATE := $(shell git log -1 --format=%cd --date=short)
ifeq ($(GIT_CURRENT_TAG),$(GIT_CURRENT_DESC))
MODULES_BUILD :=
else ifeq ($(GIT_CURRENT_BRANCH),master)
MODULES_BUILD := +$(subst $(GIT_CURRENT_TAG)-,,$(GIT_CURRENT_DESC))
else
MODULES_BUILD := +$(GIT_CURRENT_BRANCH)$(subst $(GIT_CURRENT_TAG),,$(GIT_CURRENT_DESC))
endif

# determine RPM release
# retrieve all parts of the release number and increase minor release number
MODULES_RELEASE_BASE := $(firstword $(subst -, ,$(MODULES_RELEASE)))
ifeq ($(MODULES_RELEASE),$(MODULES_RELEASE_BASE))
MODULES_RELEASE_SUFFIX :=
else
MODULES_RELEASE_SUFFIX := $(subst $(MODULES_RELEASE_BASE)-,,$(MODULES_RELEASE))
endif
MODULES_LAST_RPM_VERSREL := $(shell grep -Pzo -m 1 '%changelog\n+\*.* - \K.*\n' \
	contrib/rpm/environment-modules.spec.in)

MODULES_LAST_RPM_RELEASE := $(subst $(MODULES_RELEASE_BASE)-,,$(MODULES_LAST_RPM_VERSREL))
ifneq ($(MODULES_RELEASE_SUFFIX),)
MODULES_LAST_RPM_RELEASE := $(subst .$(MODULES_RELEASE_SUFFIX),,$(MODULES_LAST_RPM_RELEASE))
endif

# use last release if we currently sat on tag
ifeq ($(GIT_CURRENT_TAG),$(GIT_CURRENT_DESC))
MODULES_RPM_RELEASE := $(MODULES_LAST_RPM_RELEASE)
else
MODULES_LAST_RPM_RELEASE_P1 := $(firstword $(subst ., ,$(MODULES_LAST_RPM_RELEASE)))
MODULES_LAST_RPM_RELEASE_P2 := $(subst $(MODULES_LAST_RPM_RELEASE_P1).,,$(MODULES_LAST_RPM_RELEASE))

ifeq ($(MODULES_LAST_RPM_RELEASE_P2),)
MODULES_RPM_RELEASE_P2 := 1
else
MODULES_RPM_RELEASE_P2 := $(shell echo $$(($(MODULES_LAST_RPM_RELEASE_P2)+1)))
endif

MODULES_RPM_RELEASE := $(MODULES_LAST_RPM_RELEASE_P1).$(MODULES_RPM_RELEASE_P2)
ifneq ($(MODULES_RELEASE_SUFFIX),)
MODULES_RPM_RELEASE := $(MODULES_RPM_RELEASE).$(MODULES_RELEASE_SUFFIX)
endif
MODULES_RPM_RELEASE := $(MODULES_RPM_RELEASE)$(subst -,.,$(MODULES_BUILD))
endif

else
# source version definitions shared across the Makefiles of this project
ifneq ($(wildcard version.inc),version.inc)
  $(error version.inc is missing)
endif
include version.inc
endif

define translate-in-script
sed -e 's|@prefix@|$(prefix)|g' \
	-e 's|@libexecdir@|$(libexecdir)|g' \
	-e 's|@TCLSHDIR@/tclsh|$(TCLSH)|g' \
	-e 's|@TCLSH@|$(TCLSH)|g' \
	-e 's|@MODULES_RELEASE@|$(MODULES_RELEASE)|g' \
	-e 's|@MODULES_BUILD@|$(MODULES_BUILD)|g' \
	-e 's|@MODULES_RPM_RELEASE@|$(MODULES_RPM_RELEASE)|g' \
	-e 's|@MODULES_BUILD_DATE@|$(MODULES_BUILD_DATE)|g' $< > $@
endef

ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
# rebuild if git repository changed
version.inc: version.inc.in .git/index
	$(translate-in-script)

contrib/rpm/environment-modules.spec: contrib/rpm/environment-modules.spec.in .git/index
	$(translate-in-script)

else
# avoid shared definitions to be rebuilt by make
version.inc: ;

# do not rebuild spec file if not in git repository
contrib/rpm/environment-modules.spec: ;
endif

DIST_PREFIX := modules-$(MODULES_RELEASE)$(MODULES_BUILD)

# avoid shared definitions to be rebuilt by make
Makefile.inc: ;

modulecmd.tcl: modulecmd.tcl.in version.inc
	$(translate-in-script)
	chmod +x $@

ChangeLog:
	contrib/gitlog2changelog.py

README:
	sed -e '/^\[\!\[.*\].*/d' $@.md > $@

contrib/scripts/add.modules: contrib/scripts/add.modules.in
	$(translate-in-script)

# compatibility version-related rules
$(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog:
	make -C $(COMPAT_DIR) $(@F)

ifeq ($(compatversion),y)
install: modulecmd.tcl ChangeLog README contrib/scripts/add.modules \
	$(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog
else
install: modulecmd.tcl ChangeLog README contrib/scripts/add.modules
endif
	mkdir -p $(DESTDIR)$(libexecdir)
	mkdir -p $(DESTDIR)$(bindir)
	cp modulecmd.tcl $(DESTDIR)$(libexecdir)/
	chmod +x $(DESTDIR)$(libexecdir)/modulecmd.tcl
ifeq ($(compatversion),y)
	cp $(COMPAT_DIR)/modulecmd $(DESTDIR)$(libexecdir)/modulecmd-compat
	chmod +x $(DESTDIR)$(libexecdir)/modulecmd-compat
endif
	cp contrib/envml $(DESTDIR)$(bindir)/
	chmod +x $(DESTDIR)$(bindir)/envml
	cp contrib/scripts/add.modules $(DESTDIR)$(bindir)/
	chmod +x $(DESTDIR)$(bindir)/add.modules
	cp contrib/scripts/mkroot $(DESTDIR)$(bindir)/
	chmod +x $(DESTDIR)$(bindir)/mkroot
ifeq ($(docinstall),y)
	mkdir -p $(DESTDIR)$(docdir)
	cp COPYING.GPLv2 $(DESTDIR)$(docdir)/
	cp ChangeLog $(DESTDIR)$(docdir)/
	cp README $(DESTDIR)$(docdir)/
ifeq ($(compatversion),y)
	cp $(COMPAT_DIR)/ChangeLog $(DESTDIR)$(docdir)/ChangeLog-compat
	cp $(COMPAT_DIR)/NEWS $(DESTDIR)$(docdir)/NEWS-compat
endif
endif
	make -C init install DESTDIR=$(DESTDIR)
	make -C doc install DESTDIR=$(DESTDIR)
	@echo
	@echo "NOTICE: Modules installation is complete."
	@echo "        Please read the 'Configuration' section in INSTALL.txt to learn"
	@echo "        how to adapt your installation and make it fit your needs." >&2
	@echo

uninstall:
	rm -f $(DESTDIR)$(libexecdir)/modulecmd.tcl
ifeq ($(compatversion),y)
	rm -f $(DESTDIR)$(libexecdir)/modulecmd-compat
endif
	rm -f $(DESTDIR)$(bindir)/envml
	rm -f $(DESTDIR)$(bindir)/add.modules
	rm -f $(DESTDIR)$(bindir)/mkroot
ifeq ($(docinstall),y)
	rm -f $(addprefix $(DESTDIR)$(docdir)/,ChangeLog README COPYING.GPLv2)
ifeq ($(compatversion),y)
	rm -f $(addprefix $(DESTDIR)$(docdir)/,ChangeLog-compat NEWS-compat)
endif
endif
	make -C init uninstall DESTDIR=$(DESTDIR)
	make -C doc uninstall DESTDIR=$(DESTDIR)
	rmdir $(DESTDIR)$(libexecdir)
	rmdir $(DESTDIR)$(bindir)
	rmdir $(DESTDIR)$(datarootdir)
	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(prefix)

# include pre-generated documents not to require documentation build
# tools when installing from dist tarball
dist-tar: ChangeLog README version.inc contrib/rpm/environment-modules.spec pkgdoc
	git archive --prefix=$(DIST_PREFIX)/ --worktree-attributes \
		-o $(DIST_PREFIX).tar HEAD
	cp doc/build/MIGRATING.txt  doc/build/INSTALL.txt doc/build/NEWS.txt ./
	tar -rf $(DIST_PREFIX).tar --transform 's,^,$(DIST_PREFIX)/,' \
		ChangeLog README MIGRATING.txt INSTALL.txt NEWS.txt version.inc \
		doc/build/MIGRATING.txt doc/build/diff_v3_v4.txt \
		doc/build/INSTALL.txt doc/build/NEWS.txt \
		doc/build/module.1.in doc/build/modulefile.4 \
		contrib/rpm/environment-modules.spec
ifeq ($(compatversion) $(wildcard $(COMPAT_DIR)),y $(COMPAT_DIR))
	make -C $(COMPAT_DIR) distdir
	mv $(COMPAT_DIR)/modules-* compatdist
	tar -cf compatdist.tar --transform 's,^compatdist,$(DIST_PREFIX)/compat,' compatdist
	tar --concatenate -f $(DIST_PREFIX).tar compatdist.tar
	rm -rf compatdist
	rm compatdist.tar
endif

dist-gzip: dist-tar
	gzip -f -9 $(DIST_PREFIX).tar

dist-bzip2: dist-tar
	bzip2 -f $(DIST_PREFIX).tar

dist: dist-gzip

srpm: dist-bzip2
	rpmbuild -ts $(DIST_PREFIX).tar.bz2

clean:
	rm -f *.log *.sum
	rm -f $(COVERAGE_IFILE) $(COVERAGE_LOGFILE) $(COVERAGE_MFILE)
	rm -rf coverage
ifeq ($(wildcard .git) $(wildcard contrib/gitlog2changelog.py),.git contrib/gitlog2changelog.py)
	rm -f ChangeLog
endif
ifeq ($(wildcard .git) $(wildcard README.md),.git README.md)
	rm -f README
endif
ifeq ($(wildcard .git) $(wildcard MIGRATING.rst),.git MIGRATING.rst)
	rm -f MIGRATING.txt
endif
ifeq ($(wildcard .git) $(wildcard INSTALL.rst),.git INSTALL.rst)
	rm -f INSTALL.txt
endif
ifeq ($(wildcard .git) $(wildcard NEWS.rst),.git NEWS.rst)
	rm -f NEWS.txt
endif
	rm -f modulecmd.tcl
	rm -f contrib/scripts/add.modules
	rm -f modules-*.tar modules-*.tar.gz modules-*.tar.bz2
	rm -f modules-*.srpm
	make -C init clean
	make -C doc clean
ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
	rm -f version.inc
	rm -f contrib/rpm/environment-modules.spec
endif
ifneq ($(wildcard $(COMPAT_DIR)/Makefile),)
	make -C compat clean
endif

distclean: clean
	rm -f Makefile.inc
	rm -f site.exp
	rm -rf $(NAGELFAR_RELEASE)
ifeq ($(wildcard .git) $(wildcard $(COMPAT_DIR)),.git $(COMPAT_DIR))
	rm -rf $(COMPAT_DIR)
	git worktree prune
endif

ifeq ($(compatversion) $(wildcard $(COMPAT_DIR)),y $(COMPAT_DIR))
test: modulecmd.tcl $(COMPAT_DIR)/modulecmd
	make -C $(COMPAT_DIR) test
else
test: modulecmd.tcl
endif
	TCLSH=$(TCLSH); export TCLSH; \
	OBJDIR=`pwd -P`; export OBJDIR; \
	TESTSUITEDIR=`cd testsuite;pwd -P`; export TESTSUITEDIR; \
	runtest --srcdir $$TESTSUITEDIR --objdir $$OBJDIR $(RUNTESTFLAGS) --tool modules

testinstall:
	OBJDIR=`pwd -P`; export OBJDIR; \
	TESTSUITEDIR=`cd testsuite;pwd -P`; export TESTSUITEDIR; \
	runtest --srcdir $$TESTSUITEDIR --objdir $$OBJDIR $(RUNTESTFLAGS) --tool install


# install code coverage tool
$(NAGELFAR):
	wget http://downloads.sourceforge.net/nagelfar/$(NAGELFAR_RELEASE).tar.gz
	tar xzf $(NAGELFAR_RELEASE).tar.gz
	rm $(NAGELFAR_RELEASE).tar.gz

# instrument source file for code coverage
%.tcl_i: %.tcl $(NAGELFAR)
	$(NAGELFAR) -instrument $<

# prepare for code coverage run and make sure coverage log is clear
instrument: $(COVERAGE_IFILE)
	rm -f $(COVERAGE_LOGFILE)

# run tests on instrumented file to create coverage log
$(COVERAGE_LOGFILE): $(COVERAGE_IFILE)
	MODULECMD=./$< make test

# create markup file for better read coverage result
%.tcl_m: %.tcl_log $(NAGELFAR)
	$(NAGELFAR) -markup $*.tcl

testcoverage: instrument $(COVERAGE_MFILE)

testsyntax: $(NAGELFAR) $(COVERAGE_SRCFILE)
	$(NAGELFAR) -len 78 $(COVERAGE_SRCFILE)

=== doc/Makefile ===
.PHONY: install uninstall clean

SOURCE_DIR := source
BUILD_DIR := build

SPHINXOPTS := -q

# compatibility version-related files
COMPAT_MAN_DIR := ../compat/doc

# source definitions shared across the Makefiles of this project
ifneq ($(wildcard ../Makefile.inc),../Makefile.inc)
  $(error ../Makefile.inc is missing, please run '../configure')
endif
include ../Makefile.inc

# source version definitions shared across the Makefiles of this project
include ../version.inc

man: $(BUILD_DIR)/module.1 $(BUILD_DIR)/modulefile.4
ifeq ($(compatversion),y)
man: $(COMPAT_MAN_DIR)/module.1 $(COMPAT_MAN_DIR)/modulefile.4
endif

txt: $(BUILD_DIR)/diff_v3_v4.txt $(BUILD_DIR)/MIGRATING.txt \
	$(BUILD_DIR)/INSTALL.txt $(BUILD_DIR)/NEWS.txt

html: $(BUILD_DIR)/module.html $(BUILD_DIR)/modulefile.html \
	$(BUILD_DIR)/diff_v3_v4.html $(BUILD_DIR)/MIGRATING.html \
	$(BUILD_DIR)/INSTALL.html $(BUILD_DIR)/NEWS.html

all: man txt

# enable HTML pages build only from git repository
ifeq ($(wildcard ../.git),../.git)
all: html
endif

define translate-in-script
sed -e 's|@prefix@|$(prefix)|g' \
	-e 's|@libexecdir@|$(libexecdir)|g' \
	-e 's|@initdir@|$(initdir)|g' \
	-e 's|@modulefilesdir@|$(modulefilesdir)|g' \
	-e 's|@MODULES_RELEASE@|$(MODULES_RELEASE)|g' \
	-e 's|@MODULES_BUILD@|$(MODULES_BUILD)|g' \
	-e 's|@MODULES_BUILD_DATE@|$(MODULES_BUILD_DATE)|g' $< > $@
endef

# avoid shared definitions to be rebuilt by make
../Makefile.inc ../version.inc: ;

# build doc from source if in git repository
ifeq ($(wildcard ../.git),../.git)
$(SOURCE_DIR)/version.py: $(SOURCE_DIR)/version.py.in ../version.inc
	$(translate-in-script)

$(BUILD_DIR)/%.html: $(SOURCE_DIR)/%.rst $(SOURCE_DIR)/version.py
	$(SPHINXBUILD) $(SPHINXOPTS) -b html "$(SOURCE_DIR)" "$(BUILD_DIR)"

$(BUILD_DIR)/%.txt: $(SOURCE_DIR)/%.rst $(SOURCE_DIR)/version.py
	$(SPHINXBUILD) $(SPHINXOPTS) -b text "$(SOURCE_DIR)" "$(BUILD_DIR)"

$(BUILD_DIR)/%.4: $(SOURCE_DIR)/%.rst $(SOURCE_DIR)/version.py
	$(SPHINXBUILD) $(SPHINXOPTS) -t pathsubs -b man "$(SOURCE_DIR)" "$(BUILD_DIR)"

$(BUILD_DIR)/%.1.in: $(SOURCE_DIR)/%.rst $(SOURCE_DIR)/version.py
	$(SPHINXBUILD) $(SPHINXOPTS) -t pathsubs -b man "$(SOURCE_DIR)" "$(BUILD_DIR)"
	mv $(BUILD_DIR)/module.1 $@
endif

$(BUILD_DIR)/module.1: $(BUILD_DIR)/module.1.in
	$(translate-in-script)

# compatibility version-related rules
$(COMPAT_MAN_DIR)/module.1 $(COMPAT_MAN_DIR)/modulefile.4:
	make -C $(COMPAT_MAN_DIR) $(@F)

install: man txt
	mkdir -p $(DESTDIR)$(mandir)/man1 $(DESTDIR)$(mandir)/man4
ifeq ($(docinstall),y)
	mkdir -p $(DESTDIR)$(docdir)
	cp $(BUILD_DIR)/diff_v3_v4.txt $(DESTDIR)$(docdir)/
	cp $(BUILD_DIR)/MIGRATING.txt $(DESTDIR)$(docdir)/
	cp $(BUILD_DIR)/INSTALL.txt $(DESTDIR)$(docdir)/
	cp $(BUILD_DIR)/NEWS.txt $(DESTDIR)$(docdir)/
	cp example.txt $(DESTDIR)$(docdir)/
endif
	cp $(BUILD_DIR)/module.1 $(DESTDIR)$(mandir)/man1/
	cp $(BUILD_DIR)/modulefile.4 $(DESTDIR)$(mandir)/man4/
ifeq ($(compatversion),y)
	cp $(COMPAT_MAN_DIR)/module.1 $(DESTDIR)$(mandir)/man1/module-compat.1
	cp $(COMPAT_MAN_DIR)/modulefile.4 $(DESTDIR)$(mandir)/man4/modulefile-compat.4
endif

uninstall:
ifeq ($(docinstall),y)
	rm -f $(DESTDIR)$(docdir)/diff_v3_v4.txt
	rm -f $(DESTDIR)$(docdir)/MIGRATING.txt
	rm -f $(DESTDIR)$(docdir)/INSTALL.txt
	rm -f $(DESTDIR)$(docdir)/NEWS.txt
	rm -f $(DESTDIR)$(docdir)/example.txt
	rmdir $(DESTDIR)$(docdir)
endif
	rm -f $(DESTDIR)$(mandir)/man1/module.1
	rm -f $(DESTDIR)$(mandir)/man4/modulefile.4
ifeq ($(compatversion),y)
	rm -f $(DESTDIR)$(mandir)/man1/module-compat.1
	rm -f $(DESTDIR)$(mandir)/man4/modulefile-compat.4
endif
	rmdir $(DESTDIR)$(mandir)/man1 $(DESTDIR)$(mandir)/man4
	rmdir $(DESTDIR)$(mandir)

clean:
# do not clean generated docs if not in git repository
ifeq ($(wildcard ../.git),../.git)
ifeq ($(wildcard $(BUILD_DIR)),$(BUILD_DIR))
	rm -rf $(BUILD_DIR)
endif
	rm -f $(SOURCE_DIR)/version.py
endif
	rm -f $(BUILD_DIR)/*.1

=== init/Makefile ===
.PHONY: install uninstall clean

SH_LIKE  = sh ksh bash zsh profile.sh bash_completion
CSH_LIKE = csh tcsh tcsh_completion profile.csh
OTHER    = perl.pm python.py ruby.rb lisp tcl fish cmake r.R

# example modulefiles to install
EXAMPLE_MODFILES_SRCDIR := ../contrib/modulefiles
EXAMPLE_MODFILES = dot module-git module-info modules null use.own

# source definitions shared across the Makefiles of this project
ifneq ($(wildcard ../Makefile.inc),../Makefile.inc)
  $(error ../Makefile.inc is missing, please run '../configure')
endif
include ../Makefile.inc

# source version definitions shared across the Makefiles of this project
include ../version.inc

# kind of config file to use: modulerc or .modulespath
ifeq ($(setdotmodulespath),y)
  # both configuration files will be installed and in this case default init
  # scripts will use .modulespath prior to modulerc. If .modulespath sets a
  # module path then modulerc will be ignored
  ALL_CONFIG := .modulespath modulerc
else
  ALL_CONFIG := modulerc
endif

# generate 'module use' commands to put in modulerc from modulepath
modulerc := $(addprefix \nmodule use --append ,$(subst :, ,$(modulepath)))
# generate 'module load' commands to put in modulerc from loadedmodules
ifneq ($(loadedmodules),)
  modulerc := $(modulerc)$(addprefix \nmodule load ,\
    $(subst :, ,$(loadedmodules)))
endif

ifeq ($(compatversion),y)
SH_LIKE += profile-compat.sh
CSH_LIKE += profile-compat.csh
endif

ALL_SHELLS = $(SH_LIKE) $(CSH_LIKE) $(OTHER)

all: $(ALL_SHELLS) $(ALL_CONFIG) $(EXAMPLE_MODFILES_SRCDIR)/modules

# if enabled translate to keep text after markup elsewhere remove the
# entire line
ifeq ($(setmanpath),y)
  setmanpathre := s|@setmanpath@||g
else
  setmanpathre := /@setmanpath@/d
endif
ifeq ($(setbinpath),y)
  setbinpathre := s|@setbinpath@||g
else
  setbinpathre := /@setbinpath@/d
endif
ifeq ($(compatversion),y)
  compatversionre := s|@compatversion@||g
  notcompatversionre := /@notcompatversion@/d
else
  compatversionre := /@compatversion@/d
  notcompatversionre := s|@notcompatversion@||g
endif

define translate-in-script
sed -e 's|@prefix@|$(prefix)|g' \
	-e 's|@libexecdir@|$(libexecdir)|g' \
	-e 's|@initdir@|$(initdir)|g' \
	-e 's|@modulefilesdir@|$(modulefilesdir)|g' \
	-e 's|@bindir@|$(bindir)|g' \
	-e 's|@mandir@|$(mandir)|g' \
	-e '$(setmanpathre)' \
	-e '$(setbinpathre)' \
	-e '$(compatversionre)' \
	-e '$(notcompatversionre)' \
	-e 's|@modulerc@|$(modulerc)|g' \
	-e 's|@modulepath@|$(modulepath)|g' \
	-e 's|@SHELLNAME@|$@|g' \
	-e 's|@VERSION@|$(MODULES_RELEASE)$(MODULES_BUILD)|g' \
	-e 's|@TCLSH@|$(TCLSH)|g' $< > $@
endef

# avoid shared definitions to be rebuilt by make
../Makefile.inc ../version.inc: ;

%: %.in
	$(translate-in-script)

# tcsh is derivated from csh init script
tcsh: csh.in
	$(translate-in-script)

# this rule is needed for profile.sh to get matched
profile.sh: profile.sh.in
	$(translate-in-script)

# this rule is needed for profile-compat.sh to get matched
profile-compat.sh: profile-compat.sh.in
	$(translate-in-script)

$(EXAMPLE_MODFILES_SRCDIR)/modules: $(EXAMPLE_MODFILES_SRCDIR)/modules.in ../version.inc
	$(translate-in-script)

install: all
	mkdir -p $(DESTDIR)$(initdir)
	mkdir -p $(DESTDIR)$(initdir)/ksh-functions
	mkdir -p $(DESTDIR)$(modulefilesdir)
	cp $(ALL_SHELLS) $(DESTDIR)$(initdir)/
	cp fish_completion $(DESTDIR)$(initdir)/
	cp -r zsh-functions $(DESTDIR)$(initdir)/
	cp ksh $(DESTDIR)$(initdir)/ksh-functions/module
ifeq ($(compatversion),y)
	cp ksh $(DESTDIR)$(initdir)/ksh-functions/switchml
else
	rm -f $(DESTDIR)$(initdir)/ksh-functions/switchml
endif
	cp -P --remove-destination $(ALL_CONFIG) $(DESTDIR)$(initdir)/
ifeq ($(examplemodulefiles),y)
	cp $(addprefix $(EXAMPLE_MODFILES_SRCDIR)/,$(EXAMPLE_MODFILES)) $(DESTDIR)$(modulefilesdir)/
endif

uninstall:
	rm -f $(addprefix $(DESTDIR)$(initdir)/,$(ALL_SHELLS) fish_completion)
	rm -f $(DESTDIR)$(initdir)/ksh-functions/module
ifeq ($(compatversion),y)
	rm -f $(DESTDIR)$(initdir)/ksh-functions/switchml
endif
	rm -f $(DESTDIR)$(initdir)/zsh-functions/_module
	rm -f $(addprefix $(DESTDIR)$(initdir)/,$(ALL_CONFIG))
ifeq ($(wildcard $(DESTDIR)$(modulefilesdir)/*),)
	rmdir $(DESTDIR)$(modulefilesdir)
else
	@echo
	@echo "WARNING: $(DESTDIR)$(modulefilesdir) is not empty so skip removal" >&2
	@echo
endif
	rmdir $(DESTDIR)$(initdir)/ksh-functions
	rmdir $(DESTDIR)$(initdir)/zsh-functions
	rmdir $(DESTDIR)$(initdir)

clean:
	rm -f $(ALL_SHELLS) modulerc .modulespath $(EXAMPLE_MODFILES_SRCDIR)/modules

=== debian/changelog ===
modules (4.0.0-1) unstable; urgency=medium

  * New upstream release
    - tcl_8.6.patch upstream
    - significant rewrite to use tcl rather than C
  * Use source format 3.0; compression 'xz'
  * Standards-Version: 4.1.1

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 18 Oct 2017 10:00:28 +0100

modules (3.2.10-10) unstable; urgency=medium

  * Conflict with lmod. Closes: #846580
  * Standards-Version: 3.9.8; no changes required
  * Now use debhelper 10.
  * Move /etc/bash_completions.d -> /usr/share/bash-completions/completions
  * Close old bugs already fixed: Closes: #731974
  * Fix broken path to modulecmd in bash completions. Closes: #785223
  * Remove duplicate ref to conffile modulespath

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 02 Dec 2016 11:17:36 +0000

modules (3.2.10-9) unstable; urgency=medium

  * Now use xz compression.  
  * Build with optional tclX support. Closes: #741775.
  * Ensure bug closed after typo in last entry: Close: #731974.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 18 Mar 2014 11:54:56 +0000

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,14 @@
 Section: devel
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Standards-Version: 3.9.5
+Standards-Version: 4.1.1
 Homepage: http://modules.sourceforge.net/
-Build-Depends: tcl8.6-dev | tcl-dev, debhelper (>= 9), dejagnu
+Build-Depends: tcl8.6-dev | tcl-dev, debhelper (>= 10), dejagnu, tclx8.4-dev
 
 Package: environment-modules
 Architecture: any
-Depends: debhelper (>= 9), tcl8.6 | tcl, ${misc:Depends}, ${shlibs:Depends}
+Depends: debhelper (>= 10), tcl8.6 | tcl, ${misc:Depends}, ${shlibs:Depends}
+Conflicts: lmod
 Description: Modular system for handling environment variables
  The Modules package provides for the dynamic modification of a user's
  environment via modulefiles.  Each modulefile contains the information

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

TDIR=debian/environment-modules
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

DEB_BUILD_MAINT_OPTIONS:=hardening=+all
DEB_CFLAGS_MAINT_APPEND:= -Wall -pedantic
DEB_LDFLAGS_MAINT_APPEND:= -Wl,--as-needed
export  DEB_BUILD_MAINT_OPTIONS DEB_CFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_APPEND

# The magic debhelper  rule
%:
	dh $@ 

override_dh_auto_clean:
	$(MAKE) clean || echo "Make clean skipped"
	rm -f stamp-h

override_dh_auto_configure:
	dh_auto_configure -- \
                --prefix=/usr  --with-version-path=/usr/share/modules/versions \
		--with-module-path=/usr/share/modules/modulefiles \
		--with-tcl-ver=8.6 \
		--enable-logging \
		--bindir=/usr/bin #LDFLAGS='$(LDFLAGS) -Wl,--as-needed' CFLAGS='$(CFLAGS) '

override_dh_auto_test:
	@echo "Tests currently disabled - csh based test failing"

override_dh_auto_install:
	dh_auto_install
	# Fix brain-dead install locations.
	mv $(TDIR)/usr/modulefiles $(TDIR)/usr/share/modules
	mkdir -p $(TDIR)/usr/share/environment-modules
	mv $(TDIR)/usr/share/doc/* $(TDIR)/usr/share/environment-modules
	mv $(TDIR)/usr/share/environment-modules $(TDIR)/usr/share/doc
	mv $(TDIR)/usr/init $(TDIR)/usr/share/modules/init
	rm $(TDIR)/usr/share/doc/environment-modules/COPYING.GPLv2* $(TDIR)/usr/share/doc/environment-modules/INSTALL.txt*
	rm $(TDIR)/usr/share/doc/environment-modules/ChangeLog
	dh_link /etc/environment-modules/modulespath /usr/share/modules/init/.modulespath 
	dh_link $(LIBDIR)/modulecmd.tcl /usr/lib/modulecmd.tcl
